#
# Copyright 2020 by Delphix
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

#
# This class has been automatically generated from:
#     /delphix-dynamic-enum-parameter.json
#
# Do not edit this file manually!
#

from __future__ import unicode_literals

from delphixpy.v1_4_2.web.objects.DynamicParameter import DynamicParameter
from delphixpy.v1_4_2 import common

class __Undef(object):
    def __repr__(self):
        return "undef"

    def __setattr__(self, name, value):
        raise Exception('Cannot modify attributes of __Undef.')

_UNDEFINED = __Undef()

try:
    TEXT_TYPE = unicode
except NameError:
    TEXT_TYPE = str

class DynamicEnumParameter(DynamicParameter):
    """
    *(extends* :py:class:`v1_4_2.web.vo.DynamicParameter` *)* A dynamic
    parameter definition for enum values.
    """
    def __init__(self, undef_enabled=True):
        super(DynamicEnumParameter, self).__init__()
        self._type = ("DynamicEnumParameter", True)
        self._enum_values = (self.__undef__, True)

    API_VERSION = "1.4.2"

    @classmethod
    def from_dict(cls, data, dirty=False, undef_enabled=True):
        obj = super(DynamicEnumParameter, cls).from_dict(data, dirty, undef_enabled)
        if "enumValues" not in data:
            raise ValueError("Missing required property \"enumValues\".")
        obj._enum_values = []
        for item in data.get("enumValues") or []:
            assert isinstance(item, TEXT_TYPE), ("Expected one of [u'string'], but got %s of type %s" % (item, type(item)))
            common.validate_format(item, "None", None, None)
            obj._enum_values.append(item)
        obj._enum_values = (obj._enum_values, dirty)
        return obj

    def to_dict(self, dirty=False, belongs_to_parent=False):
        dct = super(DynamicEnumParameter, self).to_dict(dirty, belongs_to_parent)

        def dictify(obj, prop_is_list_or_vo=False):
            if isinstance(obj, list):
                return [dictify(o, prop_is_list_or_vo) for o in obj]
            elif hasattr(obj, "to_dict"):
                return obj.to_dict(dirty=dirty, belongs_to_parent=prop_is_list_or_vo)
            else:
                return obj
        if "enum_values" == "type" or (self.enum_values is not self.__undef__ and (not (dirty and not self._enum_values[1]) or isinstance(self.enum_values, list) or belongs_to_parent)):
            dct["enumValues"] = dictify(self.enum_values, prop_is_list_or_vo=True)
        return dct

    def dirty(self):
        return self.from_dict(self.to_dict(dirty=False), dirty=True)

    def force_dirty(self):
        self._enum_values = (self._enum_values[0], True)

    def is_dirty(self):
        return any([self._enum_values[1]])

    def __eq__(self, other):
        if other is None:
            return False
        if not isinstance(other, DynamicEnumParameter):
            return False
        return super(DynamicEnumParameter, self).__eq__(other) and \
               self.enum_values == other.enum_values

    def __ne__(self, other):
        return not self.__eq__(other)

    def __hash__(self):
        return id(self)

    def __repr__(self):
        return common.generate_repr_string(self)

    @property
    def enum_values(self):
        """
        Set of valid inputs for argument.

        :rtype: ``list`` of ``TEXT_TYPE``
        """
        return self._enum_values[0]

    @enum_values.setter
    def enum_values(self, value):
        self._enum_values = (value, True)

