#
# Copyright 2020 by Delphix
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

#
# This class has been automatically generated from:
#     /delphix-analytics-integer-less-than-constraint.json
#
# Do not edit this file manually!
#

from __future__ import unicode_literals

from delphixpy.v1_8_1.web.objects.IntegerConstraint import IntegerConstraint
from delphixpy.v1_8_1 import common

class __Undef(object):
    def __repr__(self):
        return "undef"

    def __setattr__(self, name, value):
        raise Exception('Cannot modify attributes of __Undef.')

_UNDEFINED = __Undef()

try:
    TEXT_TYPE = unicode
except NameError:
    TEXT_TYPE = str

class IntegerLessThanConstraint(IntegerConstraint):
    """
    *(extends* :py:class:`v1_8_1.web.vo.IntegerConstraint` *)* Constraint
    placed on a numerical axis of a particular analytics slice.
    """
    def __init__(self, undef_enabled=True):
        super(IntegerLessThanConstraint, self).__init__()
        self._type = ("IntegerLessThanConstraint", True)
        self._less_than = (self.__undef__, True)

    API_VERSION = "1.8.1"

    @classmethod
    def from_dict(cls, data, dirty=False, undef_enabled=True):
        obj = super(IntegerLessThanConstraint, cls).from_dict(data, dirty, undef_enabled)
        obj._less_than = (data.get("lessThan", obj.__undef__), dirty)
        if obj._less_than[0] is not None and obj._less_than[0] is not obj.__undef__:
            assert isinstance(obj._less_than[0], int), ("Expected one of [u'integer'], but got %s of type %s" % (obj._less_than[0], type(obj._less_than[0])))
            common.validate_format(obj._less_than[0], "None", None, None)
        return obj

    def to_dict(self, dirty=False, belongs_to_parent=False):
        dct = super(IntegerLessThanConstraint, self).to_dict(dirty, belongs_to_parent)

        def dictify(obj, prop_is_list_or_vo=False):
            if isinstance(obj, list):
                return [dictify(o, prop_is_list_or_vo) for o in obj]
            elif hasattr(obj, "to_dict"):
                return obj.to_dict(dirty=dirty, belongs_to_parent=prop_is_list_or_vo)
            else:
                return obj
        if "less_than" == "type" or (self.less_than is not self.__undef__ and (not (dirty and not self._less_than[1]) or isinstance(self.less_than, list) or belongs_to_parent)):
            dct["lessThan"] = dictify(self.less_than)
        return dct

    def dirty(self):
        return self.from_dict(self.to_dict(dirty=False), dirty=True)

    def force_dirty(self):
        self._less_than = (self._less_than[0], True)

    def is_dirty(self):
        return any([self._less_than[1]])

    def __eq__(self, other):
        if other is None:
            return False
        if not isinstance(other, IntegerLessThanConstraint):
            return False
        return super(IntegerLessThanConstraint, self).__eq__(other) and \
               self.less_than == other.less_than

    def __ne__(self, other):
        return not self.__eq__(other)

    def __hash__(self):
        return id(self)

    def __repr__(self):
        return common.generate_repr_string(self)

    @property
    def less_than(self):
        """
        The axis values must be less than than this value.

        :rtype: ``int``
        """
        return self._less_than[0]

    @less_than.setter
    def less_than(self, value):
        self._less_than = (value, True)

